//+------------------------------------------------------------------+
//|                                            Percent Of Change.mq4 |
//|                                      Copyright  2012, smallcase. |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012 smallcase."

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Blue
//---- indicator parameters
extern double percent=0.01; //תٷֱ
//---- indicator buffers
double ZigzagBuffer[];
bool downloadhistory=false;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(1);
//---- drawing settings
   SetIndexStyle(0,DRAW_SECTION);
//---- indicator buffers mapping
   SetIndexBuffer(0,ZigzagBuffer);
   SetIndexEmptyValue(0,0.0);

//---- indicator short name
   IndicatorShortName("POC("+percent+")");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int i, counted_bars = IndicatorCounted();
   int limit,whatlookfor;
   int shift,lastpos;
   double lasthigh,lastlow;

   if (counted_bars==0 && downloadhistory) // history was downloaded
      ArrayInitialize(ZigzagBuffer,0.0);
     
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
      whatlookfor=0;
      lastlow=Low[limit];
      lasthigh=High[limit];  
      
   for (shift=limit;shift>=0;shift--)
     {

      switch(whatlookfor)
        {
         case 0: // look for peak or lawn ѰҸߵߵ͵
              if (High[shift]>lastlow*(1+percent))   //ѰҵһЧߵ㣬ȥѰҵ͵ĳ
                 {
                  lasthigh=High[shift];   //ߵǵǰߵ
                  lastlow=Low[shift];  //͵Ҳǵǰ͵
                  lastpos=shift;  //һָλҲǵǰ
                  whatlookfor=-1;  //תȥ-1
                  ZigzagBuffer[shift]=lasthigh; //ֵָǵǰߵ  
                  ZigzagBuffer[limit]=Low[limit];  //ǰָǰ͵
                 }
               if (Low[shift]<lasthigh*(1-percent)) //ѰҵһЧ͵㣬ȥѰҸߵĳ
                 {
                  lastlow=Low[shift];
                  lasthigh=High[shift];
                  lastpos=shift;
                  whatlookfor=1;
                  ZigzagBuffer[shift]=lastlow;
                  ZigzagBuffer[limit]=High[limit]; 
                 }
             break;  
             
       case -1: // look for lawn ߵ㣬Ѱҵ͵
 
             if (High[shift]>lasthigh)    //߹ԭߵ£ָ
              {
               ZigzagBuffer[lastpos]=0.0;  //ǰһָ0
               lastpos=shift;             //һָǵǰλ
               lasthigh=High[shift];      //ߵǵǰߵ
               lastlow=Low[shift];        //͵Ҳǵǰ͵
               ZigzagBuffer[shift]=lasthigh; //ָǵǰߵ
               whatlookfor=-1;               //ָ-1
              }
              
             else if (Low[shift]<=lasthigh*(1-percent)) //ǰ͵͹趨תٷֱȵʱҲҵЧ͵
              {
               lasthigh=High[shift];
               lastlow=Low[shift];
               lastpos=shift;            
               ZigzagBuffer[shift]=lastlow;
               whatlookfor=1;
               }

            else if (Low[shift]<lastlow)  //ǰ͵͹ǰ͵ʱ
              {
               lastlow=Low[shift];  //ǰ͵͵
               whatlookfor=-1;
              } 
            break;
            
        case 1: // look for peak ͵㣬ѰҸߵ
            if (Low[shift]<lastlow)
              {
               ZigzagBuffer[lastpos]=0.0;
               lastpos=shift;
               lasthigh=High[shift];
               lastlow=Low[shift]; 
               ZigzagBuffer[shift]=lastlow;
               whatlookfor=1;
              }           
              
             else if (High[shift]>=lastlow*(1+percent))
              {
               lasthigh=High[shift];
               lastlow=Low[shift];
               lastpos=shift;
               ZigzagBuffer[shift]=lasthigh;
               whatlookfor=-1;
              }   

            else if (High[shift]>lasthigh)
              {
               lasthigh=High[shift];
               whatlookfor=1;
              } 

          break;  
 
         default: return; 
        }
     }
 /* 
   Print("ZigzagBuffer[1]",ZigzagBuffer[1]);
   Print("ZigzagBuffer[2]",ZigzagBuffer[2]);
   Print("ZigzagBuffer[3]",ZigzagBuffer[3]);
   Print("ZigzagBuffer[4]",ZigzagBuffer[4]);
   Print("ZigzagBuffer[5]",ZigzagBuffer[5]);
   Print("ZigzagBuffer[6]",ZigzagBuffer[6]);
   Print("ZigzagBuffer[7]",ZigzagBuffer[7]);
   Print("ZigzagBuffer[8]",ZigzagBuffer[8]);
 */ 
   return(0);
 
  }
//+------------------------------------------------------------------+